subroutine rscrmo(iocc, nomsd, nomjv)
    implicit none
#include "jeveux.h"
#include "asterfort/getvr8.h"
#include "asterfort/getvtx.h"
#include "asterfort/jedema.h"
#include "asterfort/jedetr.h"
#include "asterfort/jeecra.h"
#include "asterfort/jeexin.h"
#include "asterfort/jelira.h"
#include "asterfort/jemarq.h"
#include "asterfort/jenuno.h"
#include "asterfort/jeveuo.h"
#include "asterfort/jexnum.h"
#include "asterfort/juveca.h"
#include "asterfort/rsexch.h"
#include "asterfort/rsutnu.h"
#include "asterfort/wkvect.h"
!
    integer :: iocc
    character(len=*) :: nomsd, nomjv
!     ------------------------------------------------------------------
! ======================================================================
! COPYRIGHT (C) 1991 - 2015  EDF R&D                  WWW.CODE-ASTER.ORG
! THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
! IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
! THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
! (AT YOUR OPTION) ANY LATER VERSION.
!
! THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
! WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
! MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
! GENERAL PUBLIC LICENSE FOR MORE DETAILS.
!
! YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
! ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
!    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
! ======================================================================
!     ------------------------------------------------------------------
!     ------------------------------------------------------------------
    integer :: ibid, nbnosy, jnume, i, im, isy, nbordt
    integer :: jnosy,  iret, jmodl, np, nc, n22
    integer :: nbmodl, nbmmod
    real(kind=8) :: prec
    character(len=8) ::  docu, crit
    character(len=16) :: nomsym
    character(len=19) :: nomd2, noch19
    character(len=24) :: knum
    character(len=24), pointer :: celk(:) => null()
!     ------------------------------------------------------------------
!
    call jemarq()
!
    nomd2 = nomsd
!
    knum = '&&RSCRMO.NUME_ORDRE'
    call getvr8('RESU', 'PRECISION', iocc=iocc, scal=prec, nbret=np)
    call getvtx('RESU', 'CRITERE', iocc=iocc, scal=crit, nbret=nc)
    call rsutnu(nomsd, 'RESU', iocc, knum, nbordt,&
                prec, crit, iret)
    if (iret .ne. 0) goto 999
    call jeveuo(knum, 'L', jnume)
!
    call getvtx('RESU', 'NOM_CHAM', iocc=iocc, nbval=0, nbret=n22)
    if (n22 .ne. 0) then
        nbnosy = - n22
        call wkvect('&&RSCRMO.NOM_SYMBOL', 'V V K16', nbnosy, jnosy)
        call getvtx('RESU', 'NOM_CHAM', iocc=iocc, nbval=nbnosy, vect=zk16(jnosy),&
                    nbret=n22)
    else
        call jelira(nomd2//'.DESC', 'NOMMAX', nbnosy)
        if (nbnosy .eq. 0) goto 999
        call wkvect('&&RSCRMO.NOM_SYMBOL', 'V V K16', nbnosy, jnosy)
        do isy = 1, nbnosy
            call jenuno(jexnum(nomd2//'.DESC', isy), zk16(jnosy-1+isy))
        end do
    endif
!
    call jeexin(nomjv, iret)
    if (iret .eq. 0) then
        call wkvect(nomjv, 'V V K24', 10, jmodl)
        nbmodl = 0
        nbmmod = 10
        call jeecra(nomjv, 'LONUTI', nbmodl)
    else
        call jeveuo(nomjv, 'E', jmodl)
        call jelira(nomjv, 'LONUTI', nbmodl)
        call jelira(nomjv, 'LONMAX', nbmmod)
    endif
!
    do i = 1, nbordt
        do isy = 1, nbnosy
            nomsym = zk16(jnosy+isy-1)
            call rsexch(' ', nomsd, nomsym, zi(jnume+i-1), noch19,&
                        iret)
            if (iret .eq. 0) then
                call jeexin(noch19//'.DESC', ibid)
                if (ibid .gt. 0) then
                    call jelira(noch19//'.DESC', 'DOCU', cval=docu)
                else
                    call jelira(noch19//'.CELD', 'DOCU', cval=docu)
                endif
!
                if (docu(1:4) .eq. 'CHML') then
                    call jeveuo(noch19//'.CELK', 'L', vk24=celk)
                    do im = 1, nbmodl
                        if (zk24(jmodl+im-1) .eq. celk(1)) then
                            goto 28
                        endif
                    end do
                    nbmodl = nbmodl + 1
                    if (nbmodl .gt. nbmmod) then
                        nbmmod = 2 * nbmmod
                        call juveca(nomjv, nbmmod)
                        call jeveuo(nomjv, 'E', jmodl)
                    endif
                    zk24(jmodl+nbmodl-1) = celk(1)
                    call jeecra(nomjv, 'LONUTI', nbmodl)
28                  continue
                endif
            endif
        end do
    end do
!
    call jedetr(knum)
    call jedetr('&&RSCRMO.NOM_SYMBOL')
!
999 continue
    call jedema()
end subroutine
